#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=SamplePlugin.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****


#include <WindowsConstants.au3>

; Declare local variables used in Add line to AutoRun.cmd section
Local $AutoRun, $AddAutoRunLine, $Line, $LocalPluginpath, $LocalWorkingDir

; Option to Expand Environment Variable strings
Opt("ExpandEnvStrings",1)

; Set $MainEXEpath as an Environment Variable ($MainEXEpath and $Pluginpath are Globle variables that do not need to be declared in a plugin)
EnvSet("$MainEXEpath","%$Pluginpath%\Files")

; Make SamplePlugin Directory
DirCreate("%SystemDrive%\winpe_x86\mount\Program Files\SamplePlugin")
		
; Copy SamplePlugin files
FileCopy("%$MainEXEpath%\Sample.exe","%SystemDrive%\winpe_x86\mount\Program Files\SamplePlugin\Sample.exe",1)

; Load WinPE Software hive using REG.EXE from %SystemDrive%\Windows\System32 to HKLM\PE_SOFTWARE 
ShellExecuteWait("REG.EXE","LOAD HKLM\PE_SOFTWARE %SystemDrive%\winpe_x86\mount\windows\system32\config\SOFTWARE","","",@SW_HIDE)

; Write Registry additions to WinPE Software hive
RegWrite("HKLM\PE_SOFTWARE\SamplePlugin","ExePath","REG_SZ","x:\Program Files\SamplePlugin\Sample.exe")

; Unload WinPE Software hive using REG.EXE to save changes
ShellExecuteWait("REG.EXE","UNLOAD HKLM\PE_SOFTWARE","","",@SW_HIDE)

; Add line to AutoRun.cmd section *********************************
$LocalPluginpath = "%$Pluginpath%"
$LocalWorkingDir = "%$WorkingDir%"

; Open AutoRun.cmd in read only mode
$AutoRun = FileOpen("%$WorkingDir%\AutoRun.cmd", 0)

; Turn off Expand Environment Strings option so strings like %SYSTEMDRIVE% can be used in AutoRun.cmd
Opt("ExpandEnvStrings",0)
$AddAutoRunLine = IniRead($LocalPluginpath & "\SamplePlugin.ini","AutoRun","Add line to AutoRun.cmd","Not Found")

While 1
	
	$Line = FileReadLine($AutoRun)
	
	If @error = -1 Then 
			FileClose($AutoRun)
			; Open AutoRun.cmd in write mode
			$AutoRun = FileOpen($LocalWorkingDir & "\AutoRun.cmd", 1)
			; Write the line to AutoRun.cmd
			FileWriteLine($AutoRun, $AddAutoRunLine)
			ExitLoop
	EndIf			
	
	; Exit loop without writing line if it already exists
	If $Line = $AddAutoRunLine Then ExitLoop

WEnd

; Turn on Expand Environment Strings option for remainder of program
Opt("ExpandEnvStrings",1)

; Close AutoRun.cmd
FileClose($AutoRun)
; End Add line to AutoRun.cmd section *****************************

; Create Shortcuts
FileCreateShortcut("%SystemDrive%\Program Files\SamplePlugin\Sample.exe","%Temp%\MustangPEBuilder\Links\Desktop\SamplePlugin.lnk","x:\Program Files\SamplePlugin\","","SamplePlugin","x:\Program Files\SamplePlugin\Sample.exe")
FileCreateShortcut("%SystemDrive%\Program Files\SamplePlugin\Sample.exe","%Temp%\MustangPEBuilder\Links\StartMenu\SamplePlugin.lnk","x:\Program Files\SamplePlugin\","","SamplePlugin","x:\Program Files\SamplePlugin\Sample.exe")
FileCreateShortcut("%SystemDrive%\Program Files\SamplePlugin\Sample.exe","%Temp%\MustangPEBuilder\Links\QuickLaunch\SamplePlugin.lnk","x:\Program Files\SamplePlugin\","","SamplePlugin","x:\Program Files\SamplePlugin\Sample.exe")



